
import sys
sys.path.append('../.') # add parent folder to  PYTHONPATH
#if sys.version_info[0] >= 3:
#    raw_input = input
try:
    import ex23parse

    # If a filename has been specified, we read program from there:
    if len(sys.argv) == 2:
        text = open(sys.argv[1]).read()
    else :
        # Read input program from terminal: 
        print "Type program; OK to do it on multiple lines; terminate with  !"
        print "  as the first symbol on a line by itself:"
        print
        text = ""
        line = raw_input("")
        while line == ""  or  line[0] != "!" :
           text = text + " " + line + "\n"
           line = raw_input("")

    # parse input program:
    tree = ex23parse.parse(text)
    print "\nParse tree:"
    print tree
    print

    # write tree to file:
    output = open("tree.txt", "w")
    output.write("import BNF._ \nobject Tree{ \nval tree : Ttree = \n")
    output.write(tree)
    output.write("}\n")
    output.close()

    # run Scala as an interpreter:
    print "Scala interpreter now starts.  When finished, type  :q"
    print
    import os
    os.system("scala -i run.scala") 
    # once scala quits, we return here. 
except:  # when there's an error:
   import traceback
   traceback.print_exc()
print
raw_input("Press Enter key to terminate")

